VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmDTV 
   Caption         =   "Dynamic TreeView"
   ClientHeight    =   6135
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   8985
   LinkTopic       =   "Form1"
   ScaleHeight     =   6135
   ScaleWidth      =   8985
   StartUpPosition =   2  'CenterScreen
   Begin VB.Timer Timer1 
      Interval        =   200
      Left            =   8025
      Top             =   0
   End
   Begin VB.TextBox txtCriteria 
      Height          =   315
      Left            =   5400
      TabIndex        =   15
      Top             =   5175
      Width           =   3540
   End
   Begin VB.CommandButton cmdExit 
      Caption         =   "Exit"
      Height          =   495
      Left            =   7800
      TabIndex        =   10
      Top             =   5550
      Width           =   1065
   End
   Begin VB.ListBox lstAllFields 
      Height          =   2205
      Left            =   7125
      TabIndex        =   7
      Top             =   1200
      Width           =   1770
   End
   Begin VB.ListBox lstTables 
      Height          =   2205
      Left            =   5400
      TabIndex        =   6
      Top             =   1200
      Width           =   1710
   End
   Begin VB.CommandButton cmdBrowse 
      Caption         =   "..."
      Height          =   375
      Left            =   8520
      TabIndex        =   5
      Top             =   495
      Width           =   375
   End
   Begin MSComDlg.CommonDialog cd 
      Left            =   8475
      Top             =   0
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.CommandButton cmdClearList 
      Caption         =   "Clear List Box"
      Height          =   495
      Left            =   5400
      TabIndex        =   4
      Top             =   5550
      Width           =   1140
   End
   Begin VB.TextBox txtDB 
      Height          =   375
      Left            =   5400
      TabIndex        =   3
      Top             =   495
      Width           =   3075
   End
   Begin VB.ListBox lstFields 
      Enabled         =   0   'False
      Height          =   1035
      ItemData        =   "frmDTV.frx":0000
      Left            =   5400
      List            =   "frmDTV.frx":0002
      TabIndex        =   2
      Top             =   3675
      Width           =   3510
   End
   Begin VB.CommandButton cmdFillTree 
      Caption         =   "Fill Tree View"
      Default         =   -1  'True
      Height          =   495
      Left            =   6660
      TabIndex        =   1
      Top             =   5520
      Width           =   1140
   End
   Begin MSComctlLib.TreeView tv1 
      Height          =   5565
      Left            =   75
      TabIndex        =   0
      Top             =   495
      Width           =   5175
      _ExtentX        =   9128
      _ExtentY        =   9816
      _Version        =   393217
      LineStyle       =   1
      Sorted          =   -1  'True
      Style           =   6
      Appearance      =   1
   End
   Begin VB.Label Label6 
      Alignment       =   2  'Center
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   240
      Left            =   8475
      TabIndex        =   16
      Top             =   300
      Width           =   465
   End
   Begin VB.Label Label5 
      Alignment       =   2  'Center
      Caption         =   "Criteria on the top Level. (leave blank for all)"
      Height          =   390
      Left            =   5400
      TabIndex        =   14
      Top             =   4725
      Width           =   3540
   End
   Begin VB.Label lblDB 
      Alignment       =   2  'Center
      Caption         =   "Database"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   465
      Left            =   150
      TabIndex        =   13
      Top             =   0
      Width           =   5115
   End
   Begin VB.Label Label4 
      Alignment       =   2  'Center
      Caption         =   "Select the Database"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   240
      Left            =   5400
      TabIndex        =   12
      Top             =   0
      Width           =   3465
   End
   Begin VB.Label Label3 
      Alignment       =   2  'Center
      Caption         =   "Selected Levels of Hierarchy"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   315
      Left            =   5400
      TabIndex        =   11
      Top             =   3450
      Width           =   3465
   End
   Begin VB.Label Label2 
      Caption         =   "Dbl Click to add Fields"
      Height          =   240
      Left            =   7200
      TabIndex        =   9
      Top             =   900
      Width           =   1740
   End
   Begin VB.Label Label1 
      Caption         =   "Dbl Click to see Fields"
      Height          =   240
      Left            =   5400
      TabIndex        =   8
      Top             =   900
      Width           =   1590
   End
End
Attribute VB_Name = "frmDTV"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'*********************************************************'
'* PROGRAM:      Dynamic TreeView                        *'
'* AUTHOR:       Iouri Boutchkine                        *'
'* DESCRIPTION:  Populate a TreeView from selected table *'
'* INPUT:        Array of Fields                         *'
'*********************************************************'
Option Explicit
Dim cn As ADODB.Connection
Dim fbLabel6 As Boolean
Dim fbWrongSQLCriteria As Boolean

Private Sub cmdBrowse_Click()
'============================================================================================
On Error GoTo Cancelled
Timer1.Enabled = False
Label4.Caption = "Select database"
Label6.Caption = ""
tv1.Nodes.Clear
lstTables.Clear
lstAllFields.Clear
cmdClearList_Click

With cd
 .CancelError = True
 .Filter = "Access DB(*.mdb)|*.mdb"
 .ShowOpen
  txtDB = .FileName
End With
Set cn = Nothing
Call SetAccessConnection
Call ListTables
Exit Sub

Cancelled:
If Len(txtDB.Text) = 0 Then Timer1.Enabled = True
End Sub

Private Sub cmdClearList_Click()
'=============================================================================
lstFields.Clear
txtCriteria.Text = ""
Label5.Caption = "Criteria on the top Level. (leave blank for all)"

End Sub

Private Sub cmdExit_Click()
'=============================================================================
Unload Me
End Sub

Private Sub ListTables()
'=============================================================================
Dim cat     As ADOX.Catalog
Dim tbl     As ADOX.Table
    
    
If Len(txtDB) = 0 Then
    MsgBox "Choose the database"
    Exit Sub
End If

lstTables.Clear

' Open the catalog
Set cat = New ADOX.Catalog
cat.ActiveConnection = "Provider=Microsoft.Jet.OLEDB.4.0;" & _
 "Data Source=" & txtDB & ";"

' Loop through the tables in the database and print their names
 For Each tbl In cat.Tables
    If tbl.Type <> "VIEW" Then
        If Left$(tbl.Name, 4) <> "MSys" Then lstTables.AddItem tbl.Name
    End If
 Next
Set cat = Nothing

End Sub

Public Sub SetAccessConnection()
'==============================================================================
Dim sConn As String

sConn = "Provider=Microsoft.Jet.OLEDB.4.0;" & _
        "Data Source=" & txtDB & ";Persist Security Info=False"
Set cn = New ADODB.Connection
cn.ConnectionString = sConn
cn.Open sConn

End Sub

Private Sub cmdFillTree_Click()
'=============================================================================
Dim iIndex As Integer
Dim arrLevel() As String '2 dimensional level array

If lstFields.ListCount = 0 Then
    MsgBox "Choose Fields.", vbInformation
    Exit Sub
End If

tv1.Nodes.Clear
lblDB.Caption = txtDB.Text
ReDim arrLevel(lstFields.ListCount, 1)

'check if criteria is correct
fbWrongSQLCriteria = False
Call CheckCriteria
If fbWrongSQLCriteria Then Exit Sub

On Error Resume Next
'Here is the procedure call in order to create a TreeView up to 5 levels deep.
'Define only necessary levels (name of the fields). Only defined levels will be shown on a TreeView.
'Fields in the array can be in any order, which gives us possibility to analyze the table.

'fill the array
For iIndex = 0 To lstFields.ListCount - 1
    If lstFields.ListIndex > 4 Then Exit For
    lstFields.ListIndex = iIndex
    'first dimension - Field.Name
    arrLevel(iIndex, 0) = Trim(Left(lstFields.Text, InStr(1, lstFields.Text, "=") - 1))
    'second dimension - Field.Type
    arrLevel(iIndex, 1) = Trim(Right(lstFields.Text, Len(lstFields) - InStr(1, lstFields.Text, "=")))
Next iIndex

'call parameters: TreeView name, Array of table fields, table name, optional criterion for the first selected field
Call CreateTreeView(tv1, arrLevel(), lstTables.Text, txtCriteria.Text)
End Sub

Private Sub CreateTreeView(tv As TreeView, arrLevel() As String, ByVal sTable As String, Optional ByVal sCriteria As String)
'=============================================================================
'Style tvwTreLinesPlusMinusText
Dim nodX As Node
Dim sSQL As String
Dim rs() As ADODB.Recordset ' array of recordsets to hold records for each level of nodes
Dim arrQuote() As String    ' quotation mark array to use in building SQL
Dim iIndex As Integer
Dim i As Integer
Dim sAddInside As String
Dim sCriteria1 As String
Dim bErr3021 As Boolean

Screen.MousePointer = vbHourglass

On Error GoTo ErrorHandler:

'redim quotation mark array for each level
ReDim arrQuote(UBound(arrLevel))
'redim level array
ReDim rs(UBound(arrLevel))

'define the quotation marks for building SQL
For iIndex = 0 To UBound(arrLevel)
    Select Case arrLevel(iIndex, 1)
        Case 7 'Date
            arrQuote(iIndex) = "#"
        Case 202 'String
            arrQuote(iIndex) = "'"
        Case Else 'Other datatypes
            arrQuote(iIndex) = ""
    End Select
Next iIndex

'set root = Name of the table -> Name of the field
iIndex = 1
sAddInside = sTable & ": " & arrLevel(0, 0)
Do While iIndex < UBound(arrLevel)
    sAddInside = sAddInside & "->" & arrLevel(iIndex, 0)
    iIndex = iIndex + 1
Loop
Set nodX = tv.Nodes.Add(, , "ROOT", sAddInside)
tv.Nodes.Item(1).Bold = True 'make root note bold
nodX.Expanded = True

'set array of recordsets
For iIndex = 0 To UBound(arrLevel) - 1
    Set rs(iIndex) = New ADODB.Recordset
Next iIndex

'if no criteria passed select everything
If Len(sCriteria) > 0 Then
    Select Case arrLevel(i, 1)
        Case 2, 3, 5 'Number(int,lng,dbl)
            sCriteria = " where " & arrLevel(i, i) & sCriteria
        Case 7 'Date
            sCriteria = " where " & arrLevel(i, i) & " like " & arrQuote(i) & sCriteria & arrQuote(i)
        Case 11 'Boolean
            sCriteria = " where " & arrLevel(i, i) & " = " & sCriteria
        Case 202 'String
            sCriteria = " where " & arrLevel(i, i) & " like " & arrQuote(i) & sCriteria & arrQuote(i)
    End Select
End If


'Level 0
'-------
sSQL = "select distinct(" & arrLevel(i, i) & ") from " & sTable & sCriteria
rs(i).Open sSQL, cn, adOpenForwardOnly, adLockOptimistic

If bErr3021 Then GoTo EndOfLevel0
rs(i).MoveFirst

Do While Not rs(i).EOF
i = 0
'check value for Null and if it is true, don't show the rest of the levels
If Not IsNull(rs(i).Fields(arrLevel(i, i)).Value) And _
       Len(rs(i).Fields(arrLevel(i, i)).Value) > 0 Then
Set nodX = tv.Nodes.Add( _
           "ROOT", 4, _
           "Key" & rs(i).Fields(arrLevel(i, i)).Value, _
           rs(i).Fields(arrLevel(i, i)).Value)
nodX.Expanded = False

'start 1st level if exists
'--------------------------
If Len(arrLevel(i + 1, i)) > 0 Then 'check if the next level is entered
    If Len(sCriteria) > 0 Then
        sCriteria1 = sCriteria & " and " & arrLevel(i, i) & " = " & arrQuote(i) & _
           Replace(rs(i).Fields(arrLevel(i, i)).Value, "'", "''") & arrQuote(i)
    Else
        sCriteria1 = " where " & arrLevel(i, i) & " = " & arrQuote(i) & _
           Replace(rs(i).Fields(arrLevel(i, i)).Value, "'", "''") & arrQuote(i)
    End If
    sSQL = "select distinct(" & arrLevel(i + 1, i) & ") from " & sTable & sCriteria1
    rs(i + 1).Open sSQL, cn, adOpenForwardOnly, adLockOptimistic
    If bErr3021 Then
        rs(i + 2).Close
        GoTo EndOfLevel1
    End If
    rs(i + 1).MoveFirst
    Do While Not rs(i + 1).EOF
        'check value for Null and if it is true don't show the rest of the levels
        If Not IsNull(rs(i + 1).Fields(arrLevel(i + 1, i)).Value) And _
        Len(rs(i + 1).Fields(arrLevel(i + 1, i)).Value) > 0 Then
        Set nodX = tv.Nodes.Add( _
                   "Key" & rs(i).Fields(arrLevel(i, i)).Value, 4, _
                   "Key" & rs(i).Fields(arrLevel(i, i)).Value & _
                   rs(i + 1).Fields(arrLevel(i + 1, i)).Value, _
                   rs(i + 1).Fields(arrLevel(i + 1, i)).Value)
        nodX.Expanded = False
        
        'start 2nd level if exists
        '------------------------
        If Len(arrLevel(i + 2, i)) > 0 Then 'check if the next level is entered
            If Len(sCriteria) > 0 Then
                sCriteria1 = sCriteria & " and " & arrLevel(i, i) & " = " & arrQuote(i) & _
                   Replace(rs(i).Fields(arrLevel(i, i)).Value, "'", "''") & _
                   arrQuote(i) & " and " & arrLevel(i + 1, i) & " = " & arrQuote(i + 1) & _
                   Replace(rs(i + 1).Fields(arrLevel(i + 1, i)).Value, "'", "''") & arrQuote(i + 1)
            Else
                sCriteria1 = " where " & arrLevel(i, i) & " = " & arrQuote(i) & _
                   Replace(rs(i).Fields(arrLevel(i, i)).Value, "'", "''") & _
                   arrQuote(i) & " and " & arrLevel(i + 1, i) & " = " & arrQuote(i + 1) & _
                   Replace(rs(i + 1).Fields(arrLevel(i + 1, i)).Value, "'", "''") & arrQuote(i + 1)
            End If
            sSQL = "select distinct(" & arrLevel(i + 2, i) & ") from " & sTable & sCriteria1
            rs(i + 2).Open sSQL, cn, adOpenForwardOnly, adLockOptimistic
            rs(i + 2).MoveFirst
            If bErr3021 Then
                rs(i + 2).Close
                GoTo EndOfLevel2
            End If
            Do While Not rs(i + 2).EOF
                'check value for Null and if it is true don't show the rest of the levels
                If Not IsNull(rs(i + 2).Fields(arrLevel(i + 2, i)).Value) And _
                Len(rs(i + 2).Fields(arrLevel(i + 2, i)).Value) > 0 Then
                Set nodX = tv.Nodes.Add( _
                           "Key" & rs(i).Fields(arrLevel(i, i)).Value & _
                           rs(i + 1).Fields(arrLevel(i + 1, i)).Value, 4, _
                           "Key" & rs(i).Fields(arrLevel(i, i)).Value & _
                           rs(i + 1).Fields(arrLevel(i + 1, i)).Value & _
                           rs(i + 2).Fields(arrLevel(i + 2, i)).Value, _
                           rs(i + 2).Fields(arrLevel(i + 2, i)).Value)
                nodX.Expanded = False
                
                'start 3d level if exists
                '--------------------------
                If Len(arrLevel(i + 3, i)) > 0 Then 'check if the next level is entered
                    If Len(sCriteria) > 0 Then
                        sCriteria1 = sCriteria & " and " & arrLevel(i, i) & " = " & arrQuote(i) & _
                           Replace(rs(i).Fields(arrLevel(i, i)).Value, "'", "''") & _
                           arrQuote(i) & " and " & arrLevel(i + 1, i) & " = " & arrQuote(i + 1) _
                           & Replace(rs(i + 1).Fields(arrLevel(i + 1, i)).Value, "'", "''") & _
                           arrQuote(i + 1) & " and " & arrLevel(i + 2, i) & " = " & _
                           arrQuote(i + 2) & Replace(rs(i + 2).Fields(arrLevel(i + 2, i)).Value, "'", "''") & arrQuote(i + 2)
                    Else
                        sCriteria1 = " where " & arrLevel(i, i) & " = " & arrQuote(i) & _
                           Replace(rs(i).Fields(arrLevel(i, i)).Value, "'", "''") & _
                           arrQuote(i) & " and " & arrLevel(i + 1, i) & " = " & arrQuote(i + 1) _
                           & Replace(rs(i + 1).Fields(arrLevel(i + 1, i)).Value, "'", "''") & _
                           arrQuote(i + 1) & " and " & arrLevel(i + 2, i) & " = " & _
                           arrQuote(i + 2) & Replace(rs(i + 2).Fields(arrLevel(i + 2, i)).Value, "'", "''") & arrQuote(i + 2)
                    End If
                    sSQL = "select distinct(" & arrLevel(i + 3, i) & ") from " & _
                           sTable & sCriteria1
                    rs(i + 3).Open sSQL, cn, adOpenForwardOnly, adLockOptimistic
                    If bErr3021 Then
                        rs(i + 2).Close
                        GoTo EndOfLevel3
                    End If
                    rs(i + 3).MoveFirst
                    Do While Not rs(i + 3).EOF
                        'check value for Null and if it is true don't show the rest of the levels
                        If Not IsNull(rs(i + 3).Fields(arrLevel(i + 3, i)).Value) And _
                        Len(rs(i + 3).Fields(arrLevel(i + 3, i)).Value) > 0 Then
                        Set nodX = tv.Nodes.Add( _
                                   "Key" & rs(i).Fields(arrLevel(i, i)).Value & _
                                   rs(i + 1).Fields(arrLevel(i + 1, i)).Value & _
                                   rs(i + 2).Fields(arrLevel(i + 2, i)).Value, 4, _
                                   "Key" & rs(i).Fields(arrLevel(i, i)).Value & _
                                   rs(i + 1).Fields(arrLevel(i + 1, i)).Value & _
                                   rs(i + 2).Fields(arrLevel(i + 2, i)).Value & _
                                   rs(i + 3).Fields(arrLevel(i + 3, i)).Value, _
                                   rs(i + 3).Fields(arrLevel(i + 3, i)).Value)
                        nodX.Expanded = False
                        
                        'start 4th level if exists
                        '----------------------
                        If Len(arrLevel(i + 4, i)) > 0 Then 'check if the next level is entered
                            If Len(sCriteria) > 0 Then
                                sCriteria1 = sCriteria & " and " & _
                                   arrLevel(i, i) & " = " & _
                                   arrQuote(i) & Replace(rs(i).Fields(arrLevel(i, i)).Value, "'", "''") & arrQuote(i) & _
                                   " and " & arrLevel(i + 1, i) & " = " & _
                                   arrQuote(i + 1) & Replace(rs(i + 1).Fields(arrLevel(i + 1, i)).Value, "'", "''") & arrQuote(i + 1) & _
                                   " and " & arrLevel(i + 2, i) & " = " & _
                                   arrQuote(i + 2) & Replace(rs(i + 2).Fields(arrLevel(i + 2, i)).Value, "'", "''") & arrQuote(i + 2) & _
                                   " and " & arrLevel(i + 3, i) & " = " & _
                                   arrQuote(i + 3) & Replace(rs(i + 3).Fields(arrLevel(i + 3, i)).Value, "'", "''") & arrQuote(i + 3)
                            Else
                                sCriteria1 = " where " & _
                                   arrLevel(i, i) & " = " & _
                                   arrQuote(i) & Replace(rs(i).Fields(arrLevel(i, i)).Value, "'", "''") & arrQuote(i) & _
                                   " and " & arrLevel(i + 1, i) & " = " & _
                                   arrQuote(i + 1) & Replace(rs(i + 1).Fields(arrLevel(i + 1, i)).Value, "'", "''") & arrQuote(i + 1) & _
                                   " and " & arrLevel(i + 2, i) & " = " & _
                                   arrQuote(i + 2) & Replace(rs(i + 2).Fields(arrLevel(i + 2, i)).Value, "'", "''") & arrQuote(i + 2) & _
                                   " and " & arrLevel(i + 3, i) & " = " & _
                                   arrQuote(i + 3) & Replace(rs(i + 3).Fields(arrLevel(i + 3, i)).Value, "'", "''") & arrQuote(i + 3)
                            End If
                            sSQL = "select distinct(" & arrLevel(i + 4, i) & ") from " & _
                                   sTable & sCriteria1
                            rs(i + 4).Open sSQL, cn, adOpenForwardOnly, adLockOptimistic
                            If bErr3021 Then
                                rs(i + 2).Close
                                GoTo EndOfLevel4
                            End If
                            rs(i + 4).MoveFirst
                            Do While Not rs(i + 4).EOF
                                'check value for Null and if it is true don't show the rest of the levels
                                If Not IsNull(rs(i + 4).Fields(arrLevel(i + 4, i)).Value) And _
                                Len(rs(i + 4).Fields(arrLevel(i + 4, i)).Value) > 0 Then
                                Set nodX = tv.Nodes.Add( _
                                           "Key" & rs(i).Fields(arrLevel(i, i)).Value & _
                                           rs(i + 1).Fields(arrLevel(i + 1, i)).Value & _
                                           rs(i + 2).Fields(arrLevel(i + 2, i)).Value & _
                                           rs(i + 3).Fields(arrLevel(i + 3, i)).Value, 4, _
                                           "Key" & rs(i).Fields(arrLevel(i, i)).Value & _
                                           rs(i + 1).Fields(arrLevel(i + 1, i)).Value & _
                                           rs(i + 2).Fields(arrLevel(i + 2, i)).Value & _
                                           rs(i + 3).Fields(arrLevel(i + 3, i)).Value & _
                                           rs(i + 4).Fields(arrLevel(i + 4, i)).Value, _
                                           rs(i + 4).Fields(arrLevel(i + 4, i)).Value)
                                nodX.Expanded = False
                                
                                '---------------------------'
                                'here we can add more levels'
                                '---------------------------'
                                
                                End If 'Not IsNull 4th Level
                                rs(i + 4).MoveNext
                            Loop 'rs4 - end of 4th level
                            rs(i + 4).Close '4th level
                         End If 'Len(arrLevel(4)) > 0
                        End If 'Not IsNull 3d Level
EndOfLevel4:
                        bErr3021 = False
                        rs(i + 3).MoveNext
                    Loop 'rs3 - end of the 3d level
                    rs(i + 3).Close '3d level
                End If 'Len(arrLevel(3)) > 0
                End If 'Not IsNull 2nd Level
EndOfLevel3:
                bErr3021 = False
                rs(i + 2).MoveNext
            Loop 'rs2 - end of the 2nd level
            rs(i + 2).Close
        End If 'Len(arrLevel(2)) > 0
        End If 'Not IsNull 1st Level
EndOfLevel2:
        bErr3021 = False
        rs(i + 1).MoveNext
    Loop 'rs1 - end of the first level
    rs(i + 1).Close
End If 'len(arrLevel(1))>0
End If 'Not IsNull Level 0
EndOfLevel1:
bErr3021 = False
rs(i).MoveNext
Loop 'rs0 - end of level 0

EndOfLevel0:

bErr3021 = False
rs(i).Close

Set nodX = Nothing
For iIndex = 0 To UBound(arrLevel) - 1
    Set rs(iIndex) = Nothing
Next iIndex

Screen.MousePointer = vbDefault
Exit Sub

ErrorHandler:
If Err.Number = 3021 Then
    bErr3021 = True
    Resume Next
Else
    Set nodX = Nothing
    For iIndex = 0 To UBound(arrLevel) - 1
        If rs(iIndex).State = adStateOpen Then
            Set rs(iIndex) = Nothing
        End If
    Next iIndex
    tv.Nodes.Clear
    Screen.MousePointer = vbDefault
    MsgBox Err.Number & " " & Err.Description
End If
End Sub


Private Sub Form_Unload(Cancel As Integer)
'=============================================================================
On Error Resume Next
cn.Close
Set cn = Nothing
End Sub

Private Sub lstAllFields_DblClick()
'=============================================================================
If Right(lstAllFields.Text, 3) = "203" Then
    MsgBox "Memo field is not allowed", vbInformation
    Exit Sub
End If
If lstFields.ListCount < 5 Then
    lstFields.AddItem lstAllFields.Text
Else
    MsgBox "You can drill down up to 5 levels only.", vbInformation
    Exit Sub
End If

Call CheckFirstListField

End Sub

Private Sub lstTables_DblClick()
'=============================================================================
Dim f As Field
Dim rs As ADODB.Recordset
Dim sSQL As String

lstAllFields.Clear
tv1.Nodes.Clear
cmdClearList_Click

Set rs = New ADODB.Recordset

sSQL = "select * from " & lstTables.Text
rs.Open sSQL, cn, adOpenForwardOnly, adLockOptimistic

      For Each f In rs.Fields
            lstAllFields.AddItem f.Name & "   =    " & f.Type
      Next f
rs.Close
Set rs = Nothing
End Sub

Private Sub CheckFirstListField()
'=============================================================================
lstFields.ListIndex = 0
Select Case Right(lstFields.Text, 3)
    Case 2, 3, 5 'Number
        Label5.Caption = "Criteria on the top Level. (leave blank for all)         Use =,>,>=,<,<="
    Case 7 'Date
        Label5.Caption = "Criteria on the top Level. (leave blank for all)         Enter date. Cannot use wildcards"
    Case 11 'Boolean
        Label5.Caption = "Criteria on the top Level. (leave blank for all)         Use True, False"
    Case 202 'string
        Label5.Caption = "Criteria on the top Level. (leave blank for all)         Use % and _ wildcards"
End Select
End Sub

Private Sub Timer1_Timer()
'=============================================================================
Static iStart As Integer  'timer declarations
Dim iLength As Integer    'timer declarations
Dim sMarquee As String
Dim iRed As Integer
Dim iGreen As Integer
Dim iBlue As Integer

If fbLabel6 Then
    Label6.Caption = "V"
Else
    Label6.Caption = ""
End If
fbLabel6 = Not fbLabel6

Randomize
iRed = Int((255 * Rnd) + 1)
iGreen = Int((255 * Rnd) + 1)
iBlue = Int((255 * Rnd) + 1)
Label4.ForeColor = RGB(iRed, iGreen, iBlue)
Label4.Refresh

sMarquee = "Select Database                    "
iLength = Len(sMarquee)
If iStart = 0 Then iStart = 1
Label4.Caption = Mid$(sMarquee, iStart, iLength) & "   " & Left$(sMarquee, iStart)
iStart = iStart + 1
If iStart >= iLength Then iStart = 0

End Sub

Private Sub CheckCriteria()
'=============================================================================
lstFields.ListIndex = 0
Select Case Right(lstFields.Text, 3)
    Case 2, 3, 5 'Number
        If Not (Left(txtCriteria.Text, 1) = "=" Or _
           Left(txtCriteria.Text, 1) = ">" Or _
           Left(txtCriteria.Text, 1) = ">=" Or _
           Left(txtCriteria.Text, 1) = "<" Or _
           Left(txtCriteria.Text, 1) = "<=") Then
           MsgBox "Wrong selection criteria for numeric field.", vbInformation
           fbWrongSQLCriteria = True
        End If
    Case 7 'Date
        If Not (IsDate(txtCriteria.Text)) Then
           MsgBox "Wrong selection criteria for date field.", vbInformation
           fbWrongSQLCriteria = True
        End If
    Case 11 'Boolean
        If Not (txtCriteria.Text = "True" Or _
           txtCriteria.Text = "False") Then
           MsgBox "Wrong selection criteria for boolean field.", vbInformation
           fbWrongSQLCriteria = True
        End If
End Select
End Sub
